# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.DataMigration.V1beta1.Model.VpcPeeringConnectivity do
  @moduledoc """
  The details of the VPC where the source database is located in Google Cloud. We will use this information to set up the VPC peering connection between Cloud SQL and this VPC.

  ## Attributes

  *   `vpc` (*type:* `String.t`, *default:* `nil`) - The name of the VPC network to peer with the Cloud SQL private network.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :vpc => String.t() | nil
        }

  field(:vpc)
end

defimpl Poison.Decoder, for: GoogleApi.DataMigration.V1beta1.Model.VpcPeeringConnectivity do
  def decode(value, options) do
    GoogleApi.DataMigration.V1beta1.Model.VpcPeeringConnectivity.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.DataMigration.V1beta1.Model.VpcPeeringConnectivity do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
